PanelCti = class( nil )
PanelCti.maxChildCount = -1
PanelCti.maxParentCount = -1
PanelCti.connectionInput = sm.interactable.connectionType.logic
PanelCti.connectionOutput = sm.interactable.connectionType.logic + sm.interactable.connectionType.power
PanelCti.colorNormal = sm.color.new(0xcd1ec1ff)
PanelCti.colorHighlight = sm.color.new(0xeeeeeeff)


-----------------------------------------------------Server side--------------------------------------------------

function PanelCti.server_onCreate(self)
	self.delay = self.storage:load()
	if self.delay == nil then self.delay = 160 end
	self.x = false
	self.y = false
	self.killAt = 0
	self.interactable.active = false
	self.interactable.power = 0
end

function PanelCti.server_onFixedUpdate(self, deltaTime)

	local tick = sm.game.getCurrentTick()
	for id, parent in pairs(self.interactable:getParents()) do
		if tostring(parent:getShape():getColor()) == "eeeeeeff" and parent.active then
			self:server_gotWhite()
		end
		if tostring(parent:getShape():getColor()) == "222222ff" and parent.active then
			self:server_gotBlack()
		end
	end

	if self.x or self.y then
		if tick > self.killAt then
			self.interactable.active = false
			self.interactable.power = 0
			self.network:sendToClients("client_outputNotActive")
			self.y = false
			self.x = false
		end
	end
end


function PanelCti.server_gotWhite(self)
	self.killAt = sm.game.getCurrentTick() + self.delay
	if not self.x and not self.y then
		self.y = true
		self.interactable.active = true
		self.interactable.power = 0
		self.network:sendToClients("client_outputActive", self.x)
	end
end

function PanelCti.server_gotBlack(self)
	self.killAt = sm.game.getCurrentTick() + self.delay
	if not self.y and not self.x then
		self.x = true
		self.interactable.active = false
		self.interactable.power = 1
		self.network:sendToClients("client_outputActive", self.x)
	end
end

function PanelCti.server_changeDelay(self, change)
	if change then
		if self.delay < 400 then self.delay = self.delay + 40 else self.delay = 40 end
		self.storage:save( self.delay )
		self.network:sendToClients("client_playSound", self.delay)
	else
		self.network:sendToClients("client_playSound", self.delay + 500)
	end
end







-----------------------------------------------------Client side--------------------------------------------------

function PanelCti.client_onCreate(self)
	self.clientuvindex = 0
	self.outactiv = 0
	self:client_calledRefresh()
	self.clientdelay = 160
	self.network:sendToServer("server_changeDelay", false)
end

function PanelCti.client_outputActive(self, info)
	if info then self.outactiv = 9 else self.outactiv = 5 end
end

function PanelCti.client_outputNotActive(self)
	self.outactiv = 0
	self.clientuvindex = 1
	self:client_calledRefresh()
end

function PanelCti.client_onFixedUpdate(self, deltaTime)
	local parents = self.interactable:getParents()
	if #parents > 0 then
		if self.clientuvindex == 0 then
			self.clientuvindex =  1
			self:client_calledRefresh()
		end
	else
		if self.clientuvindex > 0 then
			self.clientuvindex = 0
			self:client_calledRefresh()
		end
	end
	if self.outactiv > 0 then self:client_calledRefresh() end
end

function PanelCti.client_calledRefresh(self)

	if self.outactiv > 0 then self.clientuvindex = self.outactiv end
	local tick = sm.game.getCurrentTick()
	for id, parent in pairs(self.interactable:getParents()) do
		if tostring(parent:getShape():getColor()) == "eeeeeeff" and parent.active then
			self.clientuvindex = self.clientuvindex + 1
		end
		if tostring(parent:getShape():getColor()) == "222222ff" and parent.active then
			self.clientuvindex = self.clientuvindex + 2
		end
	end

	self.interactable:setUvFrameIndex(self.clientuvindex)
end

function PanelCti.client_onTinker(self, character, looking)
	if not looking then return end
	self.network:sendToServer("server_changeDelay", true)
end

function PanelCti.client_playSound(self, vardel)
	if vardel > 500 then
		self.clientdelay = vardel - 500
	else
		self.clientdelay = vardel
		sm.audio.play("ConnectTool - Rotate", self.shape:getWorldPosition())
	end
	--if self.clientdelay == nil then self.clientdelay = 160 end
end

function PanelCti.client_canInteract(self)
	sm.gui.setInteractionText("Kliknij", sm.gui.getKeyBinding("Tinker"), "aby zmienic opoznienie")
	sm.gui.setInteractionText("Obecne opoznienie:", tostring(self.clientdelay / 40), "s")
	return true
end